/*
Este arquivo é parte do programa XBMCMove



    XBMCMove é um software livre; você pode redistribui-lo e/ou 

    modifica-lo dentro dos termos da Licença Pública Geral GNU como 

    publicada pela Fundação do Software Livre (FSF); na versão 2 da 

    Licença, ou (na sua opnião) qualquer versão.



    Este programa é distribuido na esperança que possa ser  util, 

    mas SEM NENHUMA GARANTIA; sem uma garantia implicita de ADEQUAÇÂO a qualquer

    MERCADO ou APLICAÇÃO EM PARTICULAR. Veja a

    Licença Pública Geral GNU para maiores detalhes.



    Você deve ter recebido uma cópia da Licença Pública Geral GNU

    junto com este programa, se não, escreva para a Fundação do Software

    Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "Socket.h"

Socket::Socket() {
    msg = 99;
    linha = NULL;
    tipo = n = 0;
}

Socket::~Socket() {

}

int Socket::conectar(int porta) {

    this->fechar = false;

    memset((char*) &sad, 0, sizeof (sad)); /* limpa estrutura sockaddr */
    sad.sin_family = AF_INET; /* configura famíjlia para Internet */

    /* Verifica argumento de linha de comando para porta de protocolo e extrai  */
    /* número de porta se é especificado. Caso contrário, usa o valor de        */
    /* porta default dado pela constante PROTOPORT                              */


    port = porta; /* usa o número de porta default */
    if (port > 0) /* teste se o valor é legal      */
        sad.sin_port = htons((u_short) port);

    //strcpy(host,"127.0.0.1");

    /* Converte nome de host para endereço IP equivalente e copia para sad   */

    if (inet_pton(AF_INET, "127.0.0.1", &sad.sin_addr) <= 0) {
        fprintf(stderr, "endereço de host inválido \n");
        msg = FALHOU;
    }

    /* Cria um socket */
    sd = socket(PF_INET, SOCK_STREAM, 0);

    if (sd < 0) {
        fprintf(stderr, "a criação de socket falhou \n");
        msg = FALHOU;
    }

    /* Conecta o socket ao servidor especificado */
    if (connect(sd, (struct sockaddr *) &sad, (socklen_t) sizeof (sad)) < 0) {
        //printf("connect falhou\n");
        msg = FALHOU;
    } else {
        //printf("Conectado!\n");
        msg = CONECTADO;
    }

    return msg;
}

int Socket::getMsg() {
    return msg;
}

int Socket::getTipo() {
    return tipo;
}

void Socket::setFechar(bool fechar) {
    this->fechar = fechar;
}

bool Socket::getFechar() {
    return this->fechar;
}

void Socket::run() {

    linha = NULL;
    n = recv(sd, buf, sizeof (buf), 0);

    if (n <= 0) {
        this->fechar = true;
    }

    while (!this->fechar) {

        n = recv(sd, buf, sizeof (buf), 0);

        if (n <= 0) {
            this->fechar = true;
        }
        
        //printf("###############################\n%s\n###########################\n",buf);
        linha = strstr(buf,"rid\":1,\"speed\":1},\"title\":\"\"},\"sender\":\"xbmc\"}}ms\":{\"data\":{\"item\":{\"type\":\"movie\"},\"player\":{\"playe");
        
        if(linha != NULL){
            msg = PLAY;
        }
        // Pegar tipo de conteudo que esta sendo reproduzido:

        linha = strstr(buf, "OnSpeedChanged");
        if (linha != NULL) { //Se velocidade da midia foi alterada
            linha = strstr(buf, "\"speed\":1");
            if (linha != NULL) {
                linha = strstr(buf, "movie");
                if (linha == NULL) { // Se não for Video
                    linha = strstr(buf, "song");
                    if (linha != NULL) { //Se for Musica
                        tipo = MUSICA;
                        //printf("Reproduzindo Musicas!\n");
                    }
                } else {
                    tipo = FILME;
                    //printf("Reproduzindo Videos normalmente!\n");
                }
            } else {
                tipo = SPEED;
            }
        } else {
            linha = strstr(buf, "movie");
            if (linha == NULL) { // Se não for Video
                linha = strstr(buf, "song");
                if (linha != NULL) { //Se for Musica
                    tipo = MUSICA;
                    //printf("Reproduzindo Musicas!\n");
                }
            } else {
                tipo = FILME;
                //printf("Reproduzindo Videos!\n");
            }
        }

        // Pegar estado do XBMC ( Se esta executando, pausado, parado...):
        bool backg = true;

        linha = strstr(buf, "OnPlay");

        if (linha != NULL) {
            msg = PLAY;
            backg = false;
        } else {
            linha = strstr(buf, "OnPause");
            if (linha != NULL) {
                msg = PAUSE;
                backg = false;
            } else {
                linha = strstr(buf, "OnStop");
                if (linha != NULL) {
                    msg = STOP;
                    tipo = MENU;
                    backg = false;
                } else {
                    linha = strstr(buf, "OnQuit");
                    if (linha != NULL) {
                        msg = CLOSE;
                        backg = false;
                        this->fechar = true;
                    }
                }
            }
        }

        // Compatibilidade com versão anterior do XBMC:

        if (backg) {

            linha = strstr(buf, "PlaybackPau");

            if (linha == NULL) {

                linha = strstr(buf, "PlaybackRes");

                if (linha != NULL) {

                    msg = RESUME;

                } else {

                    linha = strstr(buf, "PlaybackSta");

                    if (linha != NULL) {

                        msg = PLAY;

                    } else {

                        linha = strstr(buf, "PlaybackSto");

                        if (linha != NULL) {

                            msg = STOP;

                        } else {

                            linha = strstr(buf, "ApplicationSt");

                            if (linha != NULL) {

                                msg = CLOSE;
                                this->fechar = true;

                            } else {

                                linha = strstr(buf, "PlaybackEnd");

                                if (linha != NULL) {

                                    msg = END;

                                }
                            }
                        }
                    }
                }
            } else {
                msg = PAUSE;
            }

        } //FIM if (backg)

        linha = NULL;
    }

    msg = CLOSE;
    /* Feche o socket */
    close(sd);

    /* Termine o programa de maneira adequada */
    //return 0;
}
