/*
Este arquivo é parte do programa XBMCMove



    XBMCMove é um software livre; você pode redistribui-lo e/ou 

    modifica-lo dentro dos termos da Licença Pública Geral GNU como 

    publicada pela Fundação do Software Livre (FSF); na versão 2 da 

    Licença, ou (na sua opnião) qualquer versão.



    Este programa é distribuido na esperança que possa ser  util, 

    mas SEM NENHUMA GARANTIA; sem uma garantia implicita de ADEQUAÇÂO a qualquer

    MERCADO ou APLICAÇÃO EM PARTICULAR. Veja a

    Licença Pública Geral GNU para maiores detalhes.



    Você deve ter recebido uma cópia da Licença Pública Geral GNU

    junto com este programa, se não, escreva para a Fundação do Software

    Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/** 
 * @file
 * File:   Socket.h
 * Author: diogo
 *
 * Created on 16 de Fevereiro de 2012, 08:05
 * 
 * Classe para monitorar socket local em busca de novas mensagens.
 * 
 */

#ifndef SOCKET_H
#define	SOCKET_H

//DEFINES para MSG

#define CONECTADO       0
#define FALHOU          1
#define CLOSE           2

#define RESUME          10 // Na versão nova não existe mais!
#define PLAY            11
#define PAUSE           12
#define STOP            13
#define END             14 // Na versão nova não existe mais!

//DIFINES para TIPO ( Versão nova)

#define MENU            0
#define FILME           1
#define MUSICA          2
#define SPEED           3


#include <stdio.h>
#include <stdlib.h>
#include <string>
#include "Thread.h"

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <cstring>
using std::string;

class Socket : public Thread {
public:
    /**
     *  Retorna valor da mensagem recebida do XBMC
     */
    int getMsg();
    /**
     *  Retorna tipo de conteudo que o XBMC esta reproduzindo
     */
    int getTipo();
    /**
     *  Função que conecta ao XBMC pela porta especifida e retorna se conectou ou não
     */
    int conectar(int porta);
    /**
     *  Seta variavel Fechar, fazendo com que o socjet seja finalizado!
     */
    void setFechar(bool fechar);
    /**
     *  Contrutor
     */
    Socket();
    /**
     *  Descontrutor
     */
    ~Socket();
    /**
     *  Retorna valor da variavel fechar
     */
    bool getFechar();
    //void monitorar();

private:

    void run();
    struct sockaddr_in sad; /* a estrutura para manter um endereço IP           */
    int port; /* número de porta de protocolo                     */
    char *host; /* ponteiro para nome de host                       */
    char * linha;
    int tipo; // Tipo de conteudo
    int n;
    int sd; //descritor de socket 
    char buf[100]; // buffer para dados do servidor
    int msg;
    bool fechar;

};

#endif	/* SOCKET_H */

