/*
Este arquivo é parte do programa XBMCMove



    XBMCMove é um software livre; você pode redistribui-lo e/ou 

    modifica-lo dentro dos termos da Licença Pública Geral GNU como 

    publicada pela Fundação do Software Livre (FSF); na versão 2 da 

    Licença, ou (na sua opnião) qualquer versão.



    Este programa é distribuido na esperança que possa ser  util, 

    mas SEM NENHUMA GARANTIA; sem uma garantia implicita de ADEQUAÇÂO a qualquer

    MERCADO ou APLICAÇÃO EM PARTICULAR. Veja a

    Licença Pública Geral GNU para maiores detalhes.



    Você deve ter recebido uma cópia da Licença Pública Geral GNU

    junto com este programa, se não, escreva para a Fundação do Software

    Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/** 
 * @file
 * File:   XBMCMove.cpp
 * Author: diogo
 *
 * Arquivo principal do XBMCMove
 */

#include "kinect.h"
#include "teclado.h"
#include "Socket.h"

#define PORTA 9090 /**< Porta aberta pelo XBMC */

/**
 * Programa principal
 */
int main() {

    printf("XBMCMove iniciado!\n");
    Socket * xbmc = new Socket();        
    pthread_t thread;
    long t;
    
    printf("[INFO] Conectando ao XBMC!\n");

    do {
        msg = xbmc->conectar(PORTA); // Conecta ao XBMC e joga status em msg
        if (msg == FALHOU) {
            sleep(2);
        }
    } while (msg == FALHOU);

    rodando = true;
    printf("[INFO] Conectado ao XBMC!\n");

    xbmc->Start(); //Inicia Thread que fica ouvindo novas mensagens;

    printf("[INFO]Aguardando Dispositivo!\n");

    do {
        carregarKinect();
        if (rc != XN_STATUS_OK) {
            sleep(2);
        }
        msg = xbmc->getMsg();
        if (msg == CLOSE) {
            printf("[INFO] XBMC Finalizado antes de carregar dispositivo!\n");
            delete xbmc;
            return 0;
        }
    } while (rc != XN_STATUS_OK);

    iniciar(); //Inicia Kinect

    printf("[INFO]Tudo pronto! Levante sua mão para começar!\n");

    pthread_create(&thread, NULL, update, (void *)t);

    while (rodando) { // Enquanto XBMC rodando fica nesse LOOP

        msg = xbmc->getMsg();
        tipo = xbmc->getTipo();

        pSessao(msg,tipo); //Gerencia Sessao conforme msg e tipo
            
        rodando = !xbmc->getFechar(); //Verifica se XBMC ainda esta rodando
    }
    pthread_join(thread, NULL); //Aguarda thread ser finalizada corretamente!
    xbmc->setFechar(true); // Tenta fechar socket (por segurança);
    CleanupExit();
    delete xbmc;
    printf("\n[INFO]XBMCMove Finalizado com Sucesso!\n");
    exit(0);

}
