/*
Este arquivo é parte do programa XBMCMove



    XBMCMove é um software livre; você pode redistribui-lo e/ou 

    modifica-lo dentro dos termos da Licença Pública Geral GNU como 

    publicada pela Fundação do Software Livre (FSF); na versão 2 da 

    Licença, ou (na sua opnião) qualquer versão.



    Este programa é distribuido na esperança que possa ser  util, 

    mas SEM NENHUMA GARANTIA; sem uma garantia implicita de ADEQUAÇÂO a qualquer

    MERCADO ou APLICAÇÃO EM PARTICULAR. Veja a

    Licença Pública Geral GNU para maiores detalhes.



    Você deve ter recebido uma cópia da Licença Pública Geral GNU

    junto com este programa, se não, escreva para a Fundação do Software

    Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
/** 
 * @file
 * File:   callbacks.h
 * Author: diogo
 *
 * Created on 16 de Fevereiro de 2012, 08:05
 * 
 * Arquivo com as funções de chamadas do OpenNI (Callbacks)
 * 
 */

#include "variaveis.h"

/**
 *  Procedimento para Desativar/Habilitar sessão
 */
void pSessao(int msg, int tipo) {
    if (tipo == FILME) {
        /*Ação para Filmes*/
        if (msg != amsg) {
            switch (msg) {
                case PAUSE:
                    g_pSessionManager->RemoveListener(g_pCircle);
                    g_pSessionManager->AddListener(g_pTrackPad);
                    break;
                case PLAY:
                    printf("case PLAY!\n");
                    g_pSessionManager->RemoveListener(g_pSwipeD);
                    g_pSessionManager->RemoveListener(g_pTrackPad);
                    g_pSessionManager->AddListener(g_pCircle);
                    break;
                case END:
                case STOP:
                    g_pSessionManager->AddListener(g_pSwipeD);
                    g_pSessionManager->AddListener(g_pTrackPad);
                    g_pSessionManager->RemoveListener(g_pCircle);
                    break;
                    //default:
                    //    printf("DEFAULT!\n");
            }
            amsg = msg;
        }
    }
    //-------------------------------------------------
    //if (tipo == SPEED) {
    /*Ação para quando retroceder ou avançar*/
    //    g_pSessionManager->AddListener(g_pTrackPad);
    // }
}

/**
 *  Thread disparada ao detectar um circulo para a esquerda!
 */
void * retro(void* tid) {
    teclar->simular(XK_Down);
    sleep(1);
    //teclar->simular(XK_p);
    pthread_exit(NULL);
}

/**
 *  Thread disparada ao detectar um circulo para a direita!
 */
void * fast(void* tid) {
    teclar->simular(XK_Up);
    sleep(1);
    //teclar->simular(XK_p);
    pthread_exit(NULL);
}

/**
 *  CallBack disparado quando o usuario inicia uma sessão ( Levanta o braço pela primeira vez.
 */
void XN_CALLBACK_TYPE SessionStart(const XnPoint3D& ptFocus, void *pUserCxt) {
    printf("Seção iniciada!\n");
    pSessao(msg, tipo);
}

/**
 *  CallBack disparado quando o usuário sai da frente do dispositivo ou esconde a mão
 */
void XN_CALLBACK_TYPE SessionEnd(void *pUserCxt) {
    printf("Seção encerrada!\n");
}

/**
 *  CallBack disparado quando o usuário faz um circulo, se o usuário fazer um circulo para direita avança o video
 *  e para a esquerda retrocede
 */
void XN_CALLBACK_TYPE CircleCB(XnFloat fTimes, XnBool bConfident, const XnVCircle* pCircle, void* pUserCxt) {
    if (!gCirculo) {
        if (msg != PAUSE) {

            circuloDirecaoAtual = fmod((double) fTimes, 1.0) * 2 * XnVMathCommon::PI;
            if (circuloDirecaoAtual < -4) {
                printf("Circulo para esquerda %f\n", circuloDirecaoAtual);
                pthread_create(&threadC, NULL, retro, (void *) tC);
                pthread_join(threadC, NULL); //Aguarda thread ser finalizada corretamente!
                gCirculo = false;

            } else {
                if (circuloDirecaoAtual > 4) {
                    printf("Circulo para Direita %f\n", circuloDirecaoAtual);
                    pthread_create(&threadC, NULL, fast, (void *) tC);
                    pthread_join(threadC, NULL); //Aguarda thread ser finalizada corretamente!
                    gCirculo = false;
                }
            }
            circuloDirecaoAntiga = circuloDirecaoAtual;
            //sleep(1);
        }
    }
}

/**
 *  CallBack não utilizado pelo XBMCMove
 */
void XN_CALLBACK_TYPE NoCircleCB(XnFloat fLastValue, XnVCircleDetector::XnVNoCircleReason reason, void * pUserCxt) {
    //printf("Sem Circulo!\n");
}

/**
 *  CallBack não utilizado pelo XBMCMove
 */
void XN_CALLBACK_TYPE Circle_PrimaryCreate(const XnVHandPointContext *cxt, const XnPoint3D& ptFocus, void * pUserCxt) {
    //printf("Circulo criado!\n");
}

/**
 *  CallBack não utilizado pelo XBMCMove
 */
void XN_CALLBACK_TYPE Circle_PrimaryDestroy(XnUInt32 nID, void * pUserCxt) {
    //printf("Circulo destruido!\n");
}

/**
 *  CallBack disparado quando o usuário faz gesto de tchau.
 */
void XN_CALLBACK_TYPE OnWaveCB(void* cxt) {
    //printf("Tchau!\n");
    switch (msg) {
        case PAUSE:
            teclar->simular(XK_X);
            break;
        case PLAY:
            teclar->simular(XK_space);
            break;
        default:
            teclar->simular(XK_Escape);
    }
}

/**
 *  CallBack disparado quando o usuário faz gesto direcional para a esquerda.
 */
void XN_CALLBACK_TYPE SwipeLeftCB(XnFloat fVelocity, XnFloat fAngle, void *pUserCxt) {
    if ((msg != PAUSE) && (msg != PLAY) && (msg != RESUME)) {
        teclar->simular(XK_Left);
        sleep(0.5);
    }
}

/**
 *  CallBack disparado quando o usuário faz gesto direcional para a direita.
 */
void XN_CALLBACK_TYPE SwipeRightCB(XnFloat fVelocity, XnFloat fAngle, void *pUserCxt) {
    if ((msg != PAUSE) && (msg != PLAY) && (msg != RESUME)) {
        teclar->simular(XK_Right);
        sleep(0.5);
    }
}

/**
 *  CallBack disparado quando o usuário faz gesto direcional para cima.
 */
void XN_CALLBACK_TYPE SwipeUpCB(XnFloat fVelocity, XnFloat fAngle, void *pUserCxt) {
    if ((msg != PAUSE) && (msg != PLAY) && (msg != RESUME)) {
        teclar->simular(XK_Up);
        sleep(0.5);
    }

}

/**
 *  CallBack disparado quando o usuário faz gesto direcional para baixo.
 */
void XN_CALLBACK_TYPE SwipeDownCB(XnFloat fVelocity, XnFloat fAngle, void *pUserCxt) {
    if ((msg != PAUSE) && (msg != PLAY) && (msg != RESUME)) {
        teclar->simular(XK_Down);
        sleep(0.5);
    }
}

/**
 *  CallBack não utilizado pelo XBMCMove
 */
void XN_CALLBACK_TYPE Gesture_Recognized(xn::GestureGenerator& generator, const XnChar* strGesture, const XnPoint3D* pIDPosition, const XnPoint3D* pEndPosition, void* pCookie) {
    //printf("Gesto Reconhecido: %s\n", strGesture);

    //if (!strcmp(strGesture, "Click")) {
    //    teclar.simular(XK_Return);
    //}
    //g_GestureGenerator.RemoveGesture(strGesture);
    //g_HandsGenerator.StartTracking(*pEndPosition);
}

/**
 *  CallBack não utilizado pelo XBMCMove
 */
void XN_CALLBACK_TYPE Gesture_Process(xn::GestureGenerator& generator, const XnChar* strGesture, const XnPoint3D* pPosition, XnFloat fProgress, void* pCookie) {
}


/**
 *  CallBack não utilizado pelo XBMCMove
 */
void XN_CALLBACK_TYPE Hand_Create(xn::HandsGenerator& generator, XnUserID nId, const XnPoint3D* pPosition, XnFloat fTime, void* pCookie) {
    //printf("New Hand: %d @ (%f,%f,%f)\n", nId, pPosition->X, pPosition->Y, pPosition->Z);
}

/**
 *  CallBack não utilizado pelo XBMCMove
 */
void XN_CALLBACK_TYPE Hand_Update(xn::HandsGenerator& generator, XnUserID nId, const XnPoint3D* pPosition, XnFloat fTime, void* pCookie) {
}

/**
 *  CallBack não utilizado pelo XBMCMove
 */
void XN_CALLBACK_TYPE Hand_Destroy(xn::HandsGenerator& generator, XnUserID nId, XnFloat fTime, void* pCookie) {
    //printf("Lost Hand: %d\n", nId);
    //g_GestureGenerator.AddGesture(GESTURE_TO_USE, NULL);
}

/**
 *  CallBack não utilizado pelo XBMCMove
 */
void XN_CALLBACK_TYPE TrackPad_ValueChange(XnFloat fXValue, XnFloat fYValue, void* cxt) {
    //if(TRUE == g_isPrintValueChange)
    //	  printf("Value changed: %f, %f\n", fXValue, fYValue);
    //g_fXValue = fXValue;
    //g_fYValue = fYValue;
}

/**
 *  CallBack não utilizado pelo XBMCMove
 */
void XN_CALLBACK_TYPE TrackPad_ItemHover(XnInt32 nXItem, XnInt32 nYItem, void* cxt) {
    //if(TRUE == g_isPrintItemHover)
    //  printf("Hover: %d,%d\n", nXItem, nYItem);
    //if((TRUE == g_bIsPushed) && (CurrentItem.X != nXItem || CurrentItem.Y != nYItem))
    //{
    //  g_bIsPushed = FALSE;
    //  g_nCurrentFrame = 0;
    //}
    //CurrentItem.X = nXItem;
    //CurrentItem.Y = nYItem;
}

/**
 *  CallBack disparado quando usuário faz gesto para frente com as mãos, simulando um "Enter"
 */
void XN_CALLBACK_TYPE TrackPad_ItemSelect(XnInt32 nXItem, XnInt32 nYItem, XnVDirection eDir, void* cxt) {
    //printf("Select: %d,%d (%s)\n", nXItem, nYItem, XnVDirectionAsString(eDir));
    //g_bIsPushed = TRUE;
    if (!strcmp(XnVDirectionAsString(eDir), "Forward")) { //Backward
        if (msg != PLAY) {
            if (msg == PAUSE) {
                printf("[INFO] Retornar a reprodução!\n");
                teclar->simular(XK_p);
                //teclar->simular(XK_Escape);
            } else {
                if (tipo == SPEED) {
                    teclar->simular(XK_p);
                    teclar->simular(XK_Escape);
                    gCirculo = false;
                } else {
                    printf("[INFO] Enter!\n");
                    teclar->simular(XK_Return);
                    sleep(0.5);
                }
            }
        }
    }
}

/**
 *  CallBack não utilizado pelo XBMCMove
 */
void XN_CALLBACK_TYPE TrackPad_PrimaryCreate(const XnVHandPointContext* cxt, const XnPoint3D& ptFocus, void* UserCxt) {
    //printf("TrackPad input has started!!!, point ID: [%d] ", cxt->nID);
    //printf("Starting point position: [%f],[%f],[%f]\n", cxt->ptPosition.X, cxt->ptPosition.Y, cxt->ptPosition.Z);
    g_isInputStarted = TRUE;
}

/**
 *  CallBack não utilizado pelo XBMCMove
 */
void XN_CALLBACK_TYPE TrackPad_PrimaryDestroy(XnUInt32 nID, void* UserCxt) {
    // printf("TrackPad input has stopped!!!\n");
    g_isInputStarted = FALSE;
}

/**
 *  CallBack disparado quando um novo usuário é detectado
 */
void XN_CALLBACK_TYPE User_NewUser(xn::UserGenerator& generator, XnUserID nId, void* pCookie) {
    printf("[INFO] Novo usuario, ID=%d\n", nId);
    // New user found
    if (g_bNeedPose) {
        g_UserGenerator.GetPoseDetectionCap().StartPoseDetection(g_strPose, nId);
    } else {
        g_UserGenerator.GetSkeletonCap().RequestCalibration(nId, TRUE);
    }
}
// Callback: An existing user was lost

/**
 *  CallBack não utilizado pelo XBMCMove
 */
void XN_CALLBACK_TYPE User_LostUser(xn::UserGenerator& generator, XnUserID nId, void* pCookie) {
    //printf("[INFO] Usuario %d perdido!\n", nId);
}
// Callback: Detected a pose

/**
 *  CallBack disparado quando usuário faz pose inicial (Não é utilizado pose para iniciar o XBMCMove)
 */
void XN_CALLBACK_TYPE UserPose_PoseDetected(xn::PoseDetectionCapability& capability, const XnChar* strPose, XnUserID nId, void* pCookie) {
    printf("Pose %s detected for user %d\n", strPose, nId);
    g_UserGenerator.GetPoseDetectionCap().StopPoseDetection(nId);
    g_UserGenerator.GetSkeletonCap().RequestCalibration(nId, TRUE);
}
// Callback: Started calibration

/**
 *  CallBack não utilizado pelo XBMCMove
 */
void XN_CALLBACK_TYPE UserCalibration_CalibrationStart(xn::SkeletonCapability& capability, XnUserID nId, void* pCookie) {
    //printf("[INFO] Calibração iniciada para o usuario %d!\n", nId);
}
// Callback: Finished calibration

/**
 *  CallBack disparado quando termina calibração de um usuário
 */
void XN_CALLBACK_TYPE UserCalibration_CalibrationEnd(xn::SkeletonCapability& capability, XnUserID nId, XnBool bSuccess, void* pCookie) {
    if (bSuccess) {
        // Calibration succeeded
        printf("[INFO] Calibração completa, restreando usuario %d!\n", nId);
        g_UserGenerator.GetSkeletonCap().StartTracking(nId);
        gestoTrack = true;
    } else {
        // Calibration failed
        gestoTrack = false;
        printf("[INFO]Calibração do usuario %d falhou!\n", nId);
        if (g_bNeedPose) {
            g_UserGenerator.GetPoseDetectionCap().StartPoseDetection(g_strPose, nId);
        } else {
            g_UserGenerator.GetSkeletonCap().RequestCalibration(nId, TRUE);
        }
    }
}

/**
 *  CallBack disparado quando calibração de um usuário é concluida
 */
void XN_CALLBACK_TYPE UserCalibration_CalibrationComplete(xn::SkeletonCapability& capability, XnUserID nId, XnCalibrationStatus eStatus, void* pCookie) {
    if (eStatus == XN_CALIBRATION_STATUS_OK) {
        // Calibration succeeded
        printf("[INFO] Calibração completa, restreando usuario %d!\n", nId);
        g_UserGenerator.GetSkeletonCap().StartTracking(nId);
        gestoTrack = true;
    } else {
        // Calibration failed
        gestoTrack = false;
        printf("[INFO]Calibração do usuario %d falhou!\n", nId);
        if (g_bNeedPose) {
            g_UserGenerator.GetPoseDetectionCap().StartPoseDetection(g_strPose, nId);
        } else {
            g_UserGenerator.GetSkeletonCap().RequestCalibration(nId, TRUE);
        }
    }
}
