/*
Este arquivo é parte do programa XBMCMove



    XBMCMove é um software livre; você pode redistribui-lo e/ou 

    modifica-lo dentro dos termos da Licença Pública Geral GNU como 

    publicada pela Fundação do Software Livre (FSF); na versão 2 da 

    Licença, ou (na sua opnião) qualquer versão.



    Este programa é distribuido na esperança que possa ser  util, 

    mas SEM NENHUMA GARANTIA; sem uma garantia implicita de ADEQUAÇÂO a qualquer

    MERCADO ou APLICAÇÃO EM PARTICULAR. Veja a

    Licença Pública Geral GNU para maiores detalhes.



    Você deve ter recebido uma cópia da Licença Pública Geral GNU

    junto com este programa, se não, escreva para a Fundação do Software

    Livre(FSF) Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/**
 * @file
 *  Arquivo contendo variaveis e defines do programa
 */
#define SAMPLE_XML_FILE "/etc/xbmcmove/Sample-Tracking.xml" /**< Arquivo XML de configuração do OpenNI */

//DEFINES para MSG
#define CONECTADO       0
#define FALHOU          1
#define CLOSE           2
#define RESUME          10 // Na versão nova não existe mais!
#define PLAY            11
#define PAUSE           12
#define STOP            13
#define END             14 // Na versão nova não existe mais!

//DIFINES para TIPO
#define MENU            0
#define FILME           1
#define MUSICA          2
#define SPEED           3

#include <stdio.h>
#include <XnCppWrapper.h>
#include <XnOpenNI.h>
#include <XnCodecIDs.h>
#include <XnVHandPointContext.h>
#include <XnVSessionManager.h>
#include <XnVCircleDetector.h>
#include <XnVWaveDetector.h>
#include <XnVSwipeDetector.h>
#include <XnVGesture.h>
#include <XnVSelectableSlider2D.h>
using namespace xn;

#include "teclado.h"
#include "Thread.h"
XnStatus rc; // Para verificar erros
teclado * teclar = new teclado(); /**< Instanciando Objeto Teclado */
xn::Context g_Context; //Contexto
xn::Context g_Context2; //Contexto
xn::ScriptNode g_ScriptNode; //Script de configuração Nós
XnVSessionManager * g_pSessionManager = NULL; //Gerenciador de Seção
XnVCircleDetector* g_pCircle = NULL; //Detector de circulo
XnVSwipeDetector* g_pSwipeD = NULL; //Detector de Swipe (Gestos UP,DOWN,LEFT,RIGHT)
xn::GestureGenerator g_GestureGenerator;
xn::HandsGenerator g_HandsGenerator;
XnVSelectableSlider2D* g_pTrackPad = NULL;
xn::EnumerationErrors errors;
XnVWaveDetector *wc = NULL;

xn::DepthGenerator g_DepthGenerator;
xn::UserGenerator g_UserGenerator;
xn::Player g_Player;

XnBool g_bNeedPose = FALSE;
XnChar g_strPose[20] = "";
XnUserID userIds[5] = {0};
XnUInt16 nUsers = 5;
bool gestoTrack = true;
int id = 0;
float conf = 0; // joint confidence
float rh[3]; // right hand coordinates (x[px], y[px], z[meters])
float lh[3]; // left hand coordinates
float t[3]; // torso coordinates
float head[3]; // Cabeça
//float ombroD[3]; //Ombro Direito
//float ombroE[3]; // Ombro Esquerdo
//float cotoveloE[3]; //Cotovelo Esquerdo
//float cotoveloD[3]; //Cotovelo Direito

float posInit[2];
float distInit = 0;
int volumeCont = 0;
int fecharCont = 0;

bool rodando = false;

XnCallbackHandle h1, h2;

float circuloDirecaoAntiga = 0; //Variavel para identificação da direção do circulo
float circuloDirecaoAtual = 0; //Variavel para identificação da direção do circulo
bool xbmc = false;
int msg = 99;
int amsg = 100;
int tipo = 99;
bool gFechar = false;
bool gVolume = false;
bool gCirculo = false;
pthread_t threadC; //Thread para circulo
long tC;
pthread_t threadG; //Thread para Swipes,trackpad
long tG;

XnUInt32 g_TP_XDim = 4;
XnUInt32 g_TP_YDim = 9;

XnCallbackHandle g_nItemHoverHandle = NULL;
XnCallbackHandle g_nItemSelectHandle = NULL;
XnCallbackHandle g_nValueChangeHandle = NULL;

XnCallbackHandle g_nPrimaryCreateHandle = NULL;
XnCallbackHandle g_nPrimaryDestroyHandle = NULL;

XnUInt32 g_TrackPadHandle = 0;

XnBool g_isPrintItemHover = TRUE;
XnBool g_isPrintValueChange = FALSE;
XnBool g_isInputStarted = FALSE;

XnVector3D projective;
XnSkeletonJointPosition skeletonJointPosition;

